/*
// After each name line add the course description from the description
// file.  Here is a typical example:
// 
//    Systems of linear equations, matrices, matix algebra, determinant,
//    rank, matrix inverse, gaussian elimination, vector spaces, linear
//    operator, matrix representation, isomorhpism, eigenvalues and
//    eigenvectors, applications.
*/

#include "grade.h"
 
void add_course_descr(FILE* ifp, FILE* ofp)
{
   char         course_descr_f_name[maxstring];
   char         current_name_line[maxline];
   char         line[maxline];
   int          c;
   int          i;
   int          j;
   int          n;
   int          nn;
   long         offset;
   FILE*        cdfp;
   INFO_LINE*   hp;

   printf("Here is a snapshot of your database.\n\n");
   snapshot(ifp);
   printf("%s",
      "Here is an example of a course description:\n"
      "\n"
      "   Systems of linear equations, matrices, matix algebra, determinant,\n"
      "   rank, matrix inverse, gaussian elimination, vector spaces, linear\n"
      "   operator, matrix representation, isomorhpism, eigenvalues and\n"
      "   eigenvectors, applications.\n"
      "\n"
      "Do you wish to continue?  ");
   c = reply();
   putchar('\n');
   if (c == 'n') {
      while ((c == getc(ifp)) != EOF)
	 putc(c, ofp);
      return;                          /* no course description wanted */
   }
   printf("Enter the course descripton file name:  ");
   gets(course_descr_f_name);
   putchar('\n');
   cdfp = gfopen(course_descr_f_name, "r");
   printf("Here is the contents of the file %s:\n", course_descr_f_name);
   while ((c = getc(cdfp)) != EOF)
      putchar(c);
   printf("\nDo you wish to continue?  ");
   c = reply();
   putchar('\n');
   if (c == 'n') {                       /* contents of file incorrect */
      gfclose(cdfp);
      while ((c = getc(ifp)) != EOF)
	 putc(c, ofp);
      return;
   }
   hp = cll_nail(ifp);
   n = cnt_ll_lines(hp);
   rll_lines(hp);
   offset = 0;
   while (fgets(line, maxline, ifp) != NULL && !isname(line)) {
      fputs(line, ofp);                          /* print header lines */
      offset = ftell(ifp);
   }
   fseek(ifp, offset, 0);
   for (nn = 0; fgets(line, maxline, ifp) != NULL; ++nn)
      ;                               /* count all name and info lines */
   fseek(ifp, offset, 0);
   for (i = 0; i < nn; i += n) {
      fgets(current_name_line, maxline, ifp);
      fputs(current_name_line, ofp);
      rewind(cdfp);
      while ((c = getc(cdfp)) != EOF)
	 putc(c, ofp);
      for (j = 1; j < n; ++j) {
	 fgets(line, maxline, ifp);
	 fputs(line, ofp);
      }
   }
   gfclose(cdfp);
}

void delete_course_descr(FILE* ifp, FILE* ofp)
{
   char         course_descr_f_name[maxstring];
   char         current_name_line[maxline];
   char         cd_line[maxline];
   char         line[maxline];
   int          c;
   int          cnt;
   int          i;
   int          j;
   int          n;
   int          nn;
   long         offset;
   no_yes       go;
   FILE*        cdfp;
   INFO_LINE*   hp;

   printf("%s",
      "The course description after each name line will be deleted.\n"
      "Do you wish to continue?  ");
   c = reply();
   putchar('\n');
   if (c == 'n') {
      while ((c = getc(ifp))!= EOF)
	 putc(c, ofp);
      return;                          /* no course description wanted */
   }
   printf("Enter the course description file name:  ");
   gets(course_descr_f_name);
   putchar('\n');
   cdfp = gfopen(course_descr_f_name, "r");
   printf("Here is the contents of the file %s:\n", course_descr_f_name);
   while ((c = getc(cdfp)) != EOF)
      putchar(c);
   printf("\nDo you wish to continue?  ");
   c = reply();
   putchar('\n');
   if (c == 'n') {                       /* contents of file incorrect */
      gfclose(cdfp);
      while ((c = getc(ifp)) != EOF)
	 putc(c, ofp);
      return;
   }
   rewind(cdfp);
   hp = cll_nail(ifp);
   n = cnt_ll_lines(hp);
   rll_lines(hp);
   offset = 0;
   while (fgets(line, maxline, ifp) != NULL && !isname(line)) {
      fputs(line, ofp);                          /* print header lines */
      offset = ftell(ifp);
   }
   cnt = 0;
   go = yes;
   while (fgets(cd_line, maxline, cdfp) != NULL) {
      ++cnt;
      if (fgets(line, maxline, ifp) == NULL) {
	 go = no;
	 break;
      }
      if (strcmp(cd_line, line) != 0) {
	 go = no;
	 break;
      }
   }
   gfclose(cdfp);
   if (go == no) {
      printf("%s\n%s%s\n",
	 "SORRY: The following lines do not agree:",
	 cd_line, line);
      fseek(ifp, offset, 0);
      while ((c = getc(ifp)) != EOF)
	 putc(c, ofp);
      return;
   }
   assert(cnt < n);
   fseek(ifp, offset, 0);
   for (nn = 0; fgets(line, maxline, ifp) != NULL; ++nn)
      ;                               /* count all name and info lines */
   fseek(ifp, offset, 0);
   for (i = 0; i < nn; i += n) {
      fgets(current_name_line, maxline, ifp);
      fputs(current_name_line, ofp);
      for (j = 1; j <= cnt; ++j)                /* discard these lines */
	 fgets(line, maxline, ifp);
      for ( ; j < n; ++j) {
	 fgets(line, maxline, ifp);
	 fputs(line, ofp);
      }
   }
}
