/***=
  *   Compute the totals.
  *
  *   nn      := size of go[]
  *   nscores := size of weight[]
=***/

#include "grade.h"

void c_t_s_runrun(int cut, int go[], int nn, int o_sw, char* tag,
	          dbl weight[], int nscores, FILE* ifp, FILE* ofp)
{
   char    line[maxline];
   char*   p;
   int     i;
   int     j;
   int     k;
   dbl*    score;
   dbl     temp;
   dbl     total;

   score = (double *) calloc((unsigned) nscores, sizeof(double));
   while (fgets(line, maxline, ifp) != NULL && !isname(line))
      fputs(line, ofp);                    /* run through header lines */
   do {
      fputs(line, ofp);                                   /* name line */
      k = 0;
      for (i = 1; i < nn; ++i) {
	 fgets(line, maxline, ifp);
	 fputs(line, ofp);
	 if (go[i]) {
	    p = strchr(line, ':');     /* on : so that SET() will work */
	    for (j = 0; j < go[i]; ++j) {
	       SET(p);
	       temp = 0.0;
	       sscanf(p, "%lf", &temp);         /* conversion may fail */
	       score[k++] = temp;
	    }
	 }
      }
      /***=
	*   If the order switch is on, order the scores
	*   in descending order.
      =***/
      if (o_sw)
	 for (i = 0; i < nscores - 1; ++i)
	    for (j = i + 1; j < nscores; ++j)
	       if (score[i] < score[j]) {
		  temp = score[i];
		  score[i] = score[j];
		  score[j] = temp;
	       }
      /***=
	*   Weight the scores.
      =***/
      for (i = 0; i < nscores; ++i)
	 score[i] *= weight[i];
      /***=
	*   To prepare for cutting the lowest k weighted scores,
	*   put the weighted scores in partial ascending order.
      =***/
      for (i = 0; i < cut; ++i)
	 for (j = i + 1; j < nscores; ++j)
	    if (score[i] > score[j]) {
	       temp = score[i];
	       score[i] = score[j];
	       score[j] = temp;
	    }
      /***=
	*   Finally, compute the cut total.
      =***/
      total = 0.0;
      for (i = cut; i < nscores; ++i)
	 total += score[i];
      fprintf(ofp, "%s   %.1f\n", tag, total);
   } while (fgets(line, maxline, ifp) != NULL);           /* name line */
}
