// ---
// After each name line enter a new nonscore line such as
//
//    project - simplex method in c
//
// Make sure that no colon occurs in the line.
//

#include "grade.h"

void create_new_nonscore_line(FILE* ifp, FILE* ofp)
{
   char         current_name_line[maxline];
   char         line[maxline];
   char         phrase[maxstring];
   char*        p;
   int          i;
   int          j;
   int          n;
   int          nn;
   long         offset;
   INFO_LINE*   hp;

   get_new_phrase(phrase, ifp);
   hp = cll_nail(ifp);
   n = cnt_ll_lines(hp);
   rll_lines(hp);
   offset = 0;
   while (fgets(line, maxline, ifp) != NULL && !isname(line)) {
      fputs(line, ofp);                          /* print header lines */
      offset = ftell(ifp);
   }
   fseek(ifp, offset, 0);
   for (nn = 0; fgets(line, maxline, ifp) != NULL; ++nn)
      ;                               /* count all name and info lines */
   fseek(ifp, offset, 0);
   printf("%s",
      "---\n"
      "REMEMBER:\n"
      "   Nonscore lines cannot contain a colon.\n"
      "\n"
      "Enter your lines.\n"
      "\n");
   for (i = 0; i < nn; i += n) {
      fgets(current_name_line, maxline, ifp);
      fputs(current_name_line, ofp);
      for (j = 1; j < n; ++j) {
         fgets(line, maxline, ifp);
         fputs(line, ofp);
      }
      *line = '\0';
      while (*line == '\0') {
         printf("%s\n%s%s",
            current_name_line,
            "   ", phrase);
         fgets(line, maxline, stdin);
         for (p = line; isspace(*p); ++p)
            ;
         strip(p);                         /* \n is stripped from line */
         for ( ; *p != '\0'; ++p) {
            if (*p == ':') {
               printf("ERROR: A colon is not allowed - do it again.\n\n");
               *line = '\0';
               break;
            }
         }
         for (p = line; isspace(*p); ++p)
            ;
         if (*p == '\0') {
            printf("ERROR: All white space not allowed - do it again.\n\n");
            *line = '\0';
         }
      }
      fprintf(ofp, "   %s%s\n", phrase, line);
      putchar('\n');
   }
}

// ---
// After each name line enter a new score line such as
//
//    homework:  17  19  13  11  19
//

void create_new_score_line(FILE* ifp, FILE* ofp)
{
   char     input[maxline];
   char     line[maxline];
   char     score_line[maxline];
   char     tag[maxstring];
   char*    p;
   char**   w;
   int      error;
   int      i;
   int      n;

   get_new_tag(tag, ifp);
   printf("%s\n\n%s\n\n%s",
      "Here is the new tag that you just entered.", tag,
      "How many scores are to be appended?  ");
   n = get_int_reply(1, maxline / 5);      /* a very rough upper bound */
   printf("\n");
   /*
   // Create work space.
   */
   w = (char **) gcalloc((unsigned) n, sizeof(char *));
   for (i = 0; i < n; ++i)
      w[i] = (char *) gcalloc((unsigned) maxline, sizeof(char));
   /*
   // Run through the header lines and write them to the output file.
   */
   while (fgets(line, maxline, ifp) != NULL && !isname(line))
      fputs(line, ofp);
   printf("\nEnter your data.\n\n");
   /*
   // At this point line contains the first name line.
   // We are ready to process the remainder of the input file.
   */
   do {
      fputs(line, ofp);                  /* write name line to outfile */
      do {
         printf("%s%s   ", line, tag);          /* write to the screen */
         fgets(input, maxline, stdin);
         printf("\n");
         error = (word_cnt(input) != n);
         if (error) {
            if (n == 1)
               printf("\nOnly one data item can be entered.\n");
            else
               printf("Exactly  %d  scores must be entered.\n", n);
            printf("Reenter your data.\n\n");
         }
      } while (error);
      p = skip_space(input);
      for (i = 0; i < n; ++i) {
         sscanf(p, "%s", w[i]);
         SET(p);
      }
      /***=
        *   Make the new score line.
      =***/
      strcpy(score_line, tag);
      for (i = 0; i < n; ++i) {
         strcat(score_line, blank_spaces(mnbsbs));
         strcat(score_line, w[i]);
      }
      strcat(score_line, "\n");
      fputs(score_line, ofp);
      /***=
        *   Run through the info lines.
      =***/
      while ((p = fgets(line, maxline, ifp)) != NULL && !isname(line))
         fputs(line, ofp);
   } while (p != NULL);
}
