/*
// Some functions create space dynamically and return a pointer to it.
// ((Which ones?)) ((A bad idea!))
//
// Here are some of the functions:
//
//    blank_spaces(unsigned n);
//    skip_space(char *p);                    // skip leading white space
//    strip_comment(char *line);        // strip comment and then strip()
//    vsindex(char *s, char *t);                 // variable string index
*/

/*
// Function prototypes for the cll...() functions.
//
//    cll ... := create a linked list ...
*/

LINE*         cll_nail(FILE* ifp);          /* cll name and info lines */
INFO_LINE*    cll_info_lines(FILE* ifp);             /* cll info lines */
SCORE_LINE*   cll_score_lines(FILE* ifp);           /* cll score lines */

/*
//  All other function prototypes.
*/

void    a_f_g_info(char* file_name);
void    add_course_descr(FILE *ifp, FILE *ofp);
void    append_to_score_line(FILE* ifp, FILE* ofp);
void    assign_grades(cchr* database);
void    bkup(cchr* database);
char*   blank_spaces(int n);
void    c_t_s_runrun(int cut, int go[], int nn, int o_sw, char* tag,
	             dbl weight[], int nscores, FILE* ifp, FILE* ofp);
void    capitalize(char* s);
int     chk_for_errors(cchr* database);
int     chk_for_wrt_eval_errors(cchr* database);
int     cnt_ll_lines(LINE* hp);
int     compare_lines(const void* vp, const void* vq);
int     compare_scores(const void* vp, const void* vq);
void    compute_statistics(cchr* database);
int     compute_total_scores(cchr* database);
void    copy(cchr* from, cchr* to);
void    create_new_nonscore_line(FILE* ifp, FILE* ofp);
void    create_new_score_line(FILE* ifp, FILE* ofp);
void    delete_course_descr(FILE *ifp, FILE *ofp);
void    enter_scores_or_lines(cchr* database);
void    error_exit_cannot_open(cchr* fname);
void    error_exit_too_many_cmnd_line_args();
void    error_exit_unexpected_name_line(cchr* line);
int     extract_comment(char* line, char* s);
int     extract_int(char* answer, int min, int max);
void    extract_scores(char* line, int max_fsfl, int max_rsfl, char* s);
void    extract_tag(cchr* line, int max_tfl, char* s);
char*   get_abstract_info(char* answer, cchr* database);
int     get_fsfl(char* line);
void    get_go_array(int* a, int m, int* go, int nn,
		     int* error_ptr, INFO_LINE* hp, int n);
void    get_he_line(char* he_line, char* hfn);
int     get_int_reply(int min, int max);
void    get_line_numbers(int* a_ptr[], int* m_ptr,
		         int* error_ptr, char* answer, int max_line_number);
void    get_new_phrase(char* phrase, FILE* ifp);
void    get_new_tag(char* tag, FILE* ifp);
int     get_option_from_list();
int     get_rsfl(char* line);
char*   get_string_reply(char* answer);
int     get_tfl(char* line);
dbl*    get_weight_array(int* nscores_ptr, int go[],
		         int nn, INFO_LINE* head, int w_sw);
void*   gcalloc(size_t n, size_t sizeof_something);
void    gfclose(FILE* fp);
FILE*   gfopen(cchr* filename, cchr* mode);
void    gfseek(FILE* fp, long offset, int place);
char*   ggetenv(cchr* name);
void    ggetcwd(char *cwd, size_t maxstring);
void*   gmalloc(size_t sizeof_something);
void    gremove(cchr* fname);
void    grename(cchr* from, cchr* to);
void    grewind(istream& is);                   // C++, used in publish()
void    gsystem(cchr* s);
int     is_nroff_he_line(char* line);
int     isblank(char* line);
int     isname(char* line);
int     ispermutation(int* w, int n);
int     isscore(cchr* line);
int     issimple_score(cchr* line);
int     istotal_score(cchr* line);
char*   kill_comment(char* line, char* c_ptr);
FILE*   match_ebl(cchr* database, FILE* ifp);
void    permute_lines(cchr* database);
void    pretty_print(cchr* database);
void    print_abstracts_on_paper(cchr* database, int test_mode);
void    print_database_on_paper(cchr* database, int test_mode);
void    print_on_paper(cchr* database);
void    print_roster_on_paper(cchr* database, int test_mode);
void    prn_c_t_s_info(void);
void    prn_enter_info();
void    prn_enter_info(void);
void    prn_ll_go_lines(int go[], int nn, INFO_LINE* head);
void    prn_ll_lines(LINE* head_ptr);
void    prn_main_info();
void    prn_statistics(cchr* database, SCORE_LINE* head,
		       int** cnt_array, dbl** avg_array, int* go, int nsl);
void    publish(cchr* database);
void    remake(char* line, int n, char** w, char* name_line);
void    remove_trailing_space(char* s);
void    reorder(cchr* database);
void    reorder_by(char* name_or_score, cchr* database);
void    restore_comment(char* q, char c);
void    rework(cchr* database);
int     reply();
cchr*   report(off_on val);
void    rll_lines(LINE* head_ptr);
int     score_cnt(char* line);
char*   skip_space(char* p);                  // skip leading white space
void    snapshot(FILE *ifp);
void    sort_by_score(NAIL* a, NAIL** p, int nil, int nn, FILE* ifp);
void    startup(cchr* database, FILE** ifp_ptr, char* tfn, FILE** ofp_ptr);
char*   strip(char* s);
char*   strip_comment(char* line);
void    translate_letter_grades(cchr* database, int test_mode);
void    view(cchr* database);
char*   vsindex(char* s, char* t);               // variable string index
void    whoops_not_a_score_line(int cnt, cchr* line);
void    whoops_not_enough_scores(int cnt, int m, cchr* line);
int     word_cnt(char* s);
void    wrapup(cchr* database, FILE* ifp, char* tfn, FILE* ofp);
void    wrt_ditroff_lines(cchr* database, FILE* ofp);
void    wrt_evaluations(cchr* database, int test_mode);
void    wrt_help(cchr* pgm_name);
void    wrt_more_help(cchr* pgm_name);
void    wrt_much_more_help(cchr* pgm_name);
void    wrt_nroff_lines(cchr* database, FILE* ofp);
