/*
// match_ebl := match ending blank lines in database
//
// A common error is to have the wrong number of blank lines
// at the end of the database.  This function finds the
// number of ending blank info lines, and then rewrites
// the database so that it ends with precisely that number
// of blank lines.
*/

#include "grade.h"

FILE* match_ebl(cchr* database, FILE* ifp)
{
   char    newdatabase[maxstring];
   int     c;
   int     cnt;
   int     eend;                        /* effective end of input file */
   int     i;
   int     n;
   int     nebil;                 /* number of ending blank info lines */
   FILE*   lofp;                              /* local outfile pointer */
   LINE*   hp;
   LINE*   p;

   rewind(ifp);
   hp = cll_nail(ifp);
   n = cnt_ll_lines(hp);
   if (n == 0) {
      printf("There are no name lines in your database - BYE.\n\n");
      exit(1);
   }
   nebil = 0;
   for (p = hp; p != NULL; p = p -> next)
      if (isblank(p -> line))
	 ++nebil;
      else
	 nebil = 0;
   /***=
     *   At this point nebil is known.
     *   Now rewrite the database so that it ends
     *   with precisely nebil blank lines.
   =***/
   fseek(ifp, (long) -1, 2);                  /* last byte in the file */
   while (isspace(getc(ifp)))
      fseek(ifp, (long) -2, 1);                   /* back up two bytes */
   while ((c = getc(ifp)) != EOF && c != '\n')
      ;
   eend = ftell(ifp);                   /* effective end of input file */
   cnt = 0;
   while ((c = getc(ifp)) != EOF)          /* count ending blank lines */
      if (c == '\n')
	 ++cnt;
   /***=
     *   Now test for a mismatch of ending blank lines.
     *   If a mismatch occurs, correct it.
   =***/
   rewind(ifp);
   if (cnt == nebil)                                    /* no mismatch */
      return ifp;
   else {                                                   /* trouble */
      tmpnam(newdatabase);
      lofp = gfopen(newdatabase, "w");
      for (i = 0; i < eend; ++i)
	 putc(getc(ifp), lofp);
      for (i = 0; i < nebil; ++i)
	 putc('\n', lofp);           /* matching number of blank lines */
      gfclose(ifp);
      gfclose(lofp);
      gremove(database);
      copy(newdatabase, database);
      gremove(newdatabase);
      return (gfopen(database, "r"));
   }
}
