/*
// The info lines can be permuted.
// The user is queried for the desired permutation.
*/

#include "grade.h"

void permute_lines(cchr* database)
{
   char         input[maxline];
   char         line[maxline];
   char         tfn[maxstring];
   char**       a;
   char*        s;
   int          error1;
   int          error2;
   int          error3;
   int          i;
   int          n;
   int*         w;
   FILE*        ifp;
   FILE*        ofp;
   INFO_LINE*   hp;
   INFO_LINE*   p;

   tmpnam(tfn);
   startup(database, &ifp, tfn, &ofp);
   hp = cll_info_lines(ifp);
   n = cnt_ll_lines(hp);
   if (n == 0) {
      printf("There are no info lines in your database - bye.\n\n");
      exit(1);
   }
   /*
   // Create work space.
   */
   w = (int *) gcalloc((unsigned) n, sizeof(int));
   printf("Here is a snapshot of your database.\n\n");
   snapshot(ifp);
   do {
      printf("Here are the info lines extracted from the snapshot.\n\n");
      for (i = 1, p = hp; p != NULL; ++i, p = p -> next)
	 printf("%3d%s", i, p -> line);
      printf("\n%s\n   ",
	 "Indicate by line number your desired permutation:");
      get_string_reply(input);
      putchar('\n');
      error1 = error2 = error3 = 0;
      for (s = input; *s != '\0' && !error1; ++s)
	 if (!(isspace(*s) || isdigit(*s)))
	    error1 = 1;
      if (word_cnt(input) != n)
	 error2 = 1;
      if (!(error1 || error2)) {
	 s = skip_space(input);
	 for (i = 0; i < n; ++i) {
	    sscanf(s, "%d", &w[i]);
	    SET(s);
	 }
	 error3 = !ispermutation(w, n);
      }
      if (error1 || error2 || error3)
	 printf("\n%s%s%d%s\n%s",
	    "You must input a permutation ",
	    "of the numbers  1, ... , ", n, " .",
	    "Try it again:  ");
   } while (error1 || error2 || error3);   /* user has to get it right */
   /*
   // Change to a permutation of  0, ... , n - 1
   */
   for (i = 0; i < n; ++i)
      w[i] -= 1;
   /*
   // At this point  w[]  contains a
   // permutation of the numbers  0, ... , n - 1 .
   //
   // Now we create work space for an array  a[]  of strings,
   // run through the input file, permute info lines,
   // and write to the output file.
   */
   a = (char **) gcalloc((unsigned) n, sizeof(char *));
   for (i = 0; i < n; ++i)
      a[i] = (char *) gcalloc((unsigned) maxline, sizeof(char));
   while (fgets(line, maxline, ifp) != NULL && !isname(line))
      fputs(line, ofp);                /* run through the header lines */
   do {
      if (!isname(line)) {                             /* safety check */
	 printf("\n%s\n%s\n\n",
	    "SEVERE ERROR: The following should be a name line:", line);
	 exit(1);
      }
      fputs(line, ofp);                                   /* name line */
      for (i = 0; i < n; ++i)
	 fgets(a[i], maxline, ifp);                  /* get info lines */
      for (i = 0; i < n; ++i)
	 fputs(a[w[i]], ofp);             /* write permuted info lines */
   } while (fgets(line, maxline, ifp) != NULL);
   rewind(ifp);
   /*
   // Free up the dynamically allocated space.
   */
   rll_lines(hp);
   free(w);
   for (i = 0; i < n; ++i)
      free(a[i]);
   free(a);
   wrapup(database, ifp, tfn, ofp);
}
