#include "grade.h"
#include "print_on_paper.h"

#define   BB   ".(b\n"                                  /* begin block */
#define   EB   ".)b\n"                                    /* end block */

void print_abstracts_on_paper(cchr* database, int test_mode)
{
   char         answer[maxline];
   char         cmnd[maxline];
   char         line[maxline];
   char         s1[maxword];
   char         s2[maxword];
   char*        abstract;
   char         c;
   char*        home;
   char*        p;
   char*        prn_file;
   int          cnt = 0;
   int          i;
   int          k;
   int          il_cnt;                             /* info line count */
   FILE*        ifp;
   FILE*        ofp;
   INFO_LINE*   hp;

   get_abstract_info(answer, database);
   /*
   // At this point either *answer == '\0', meaning there is nothing
   // to be done, or answer contains integers corresponding to valid
   // info lines that are to be used to create an abstract.
   */
   ifp = gfopen(database, "r");
   hp = cll_info_lines(ifp);
   il_cnt = cnt_ll_lines(hp);
   while (sscanf(answer, "%d", &k) == 1) {
      ++cnt;
      printf("*** debug:  cnt = %d\n", cnt);
      rewind(ifp);
      sprintf(s1, "%s%d%s", "tmp_pr_abs_", cnt, "_XXXXXX");
      abstract = mktemp(s1);
      ofp = gfopen(abstract, "w");
      /*
      // First run through any header lines in database.
      // Then deal with the remaining lines.
      */
      while ((p = fgets(line, maxline, ifp)) != NULL && !isname(line))
	 fputs(line, ofp);
      while (p != NULL) {
	 fputs(line, ofp);                                /* name line */
	 for (i = 1; i <= il_cnt; ++i) {
	    fgets(line, maxline, ifp);
	    if (i == k)
	       fputs(line, ofp);           /* abstraction taking place */
	 }
	 p = fgets(line, maxline, ifp);
      }
      gfclose(ofp);
      reorder_by("score", abstract);
      /***=
	*   Now we are ready to print.
      =***/
      home = ggetenv("HOME");
      sprintf(s2, "%s%s%d%s", home, "/prn_", cnt, "_XXXXXX");
      prn_file = mktemp(s2);
      ifp = gfopen(abstract, "r");
      ofp = gfopen(prn_file, "w");
      wrt_nroff_lines(database, ofp);
      while ((p = fgets(line, maxline, ifp)) != NULL && !isname(line))
	 fputs(line, ofp); /* run through any header lines in database */
      if (p != NULL) {
	 fputs(BB, ofp);
	 fputs(line, ofp);                          /* first name line */
	 while (fgets(line, maxline, ifp) != NULL) {
	    if (isname(line)) {
	       fputs(EB, ofp);
	       fputs(BB, ofp);
	    }
	    fputs(line, ofp);
	 }
	 fputs(EB, ofp);
      }
      gfclose(ifp);
      gfclose(ofp);
      if (test_mode) {
	 printf("TEST MODE:  Are you ready to view the file %s?  ", prn_file);
	 c = reply();
	 if (c == 'y' || c == '\n') {
	    strcpy(cmnd, "vi ");
	    strcat(cmnd, prn_file);
	    system(cmnd);
	 }
	 gremove(prn_file);
	 gremove(abstract);
      }
      else {
	 strcpy(cmnd, "(nroff -me -Tlpr ");
	 strcat(cmnd, prn_file);
	 strcat(cmnd, " | lpr -Pnarrow; /bin/rm ");
	 strcat(cmnd, prn_file);
	 strcat(cmnd, "; /bin/rm ");
	 strcat(cmnd, abstract);
	 strcat(cmnd, ") &");
	 system(cmnd);
	 printf("%s\n%s\n\n",
	    "Abstracted information has been sorted and is being",
	    "printed on the xerox laser printer at the computer center.");
      }
   }
   rll_lines(hp);
   gfclose(ifp);
}

// ---
// Tuesday   19:42:16 PST   28 January 1986
//   
// The database is processed for printing.
//   
// Nroff lines are prepended and blocking is inserted where appropriate.
// If a class header file exists, it will be prepended for printing as well.
// If test_option is false, the processed file is printed on the xerox laser
// printer at the computer center.  If test_option is true, it is written
// into a tmp file.
//

void print_database_on_paper(cchr* database, int test_mode)
{
   char    chfn[maxline];                     /* class header filename */
   char    cstatfn[maxline];              /* class statistics filename */
   char    cmnd[maxline];
   char    line[maxline];
   char    cx;
   char*   p;
   char*   tfn;
   int     c;
   FILE*   ifp;
   FILE*   ofp;

   tfn = mktemp("tmp_pr_db_XXXXXX");
   ofp = gfopen(tfn, "w");
   wrt_nroff_lines(database, ofp);
   strcpy(chfn, database);
   strcat(chfn, "_header");                   /* example: class_header */
   if (access(chfn, R_OK) == 0) {
      ifp = gfopen(chfn, "r");
      while ((c = getc(ifp)) != EOF)
	 putc(c, ofp);
      gfclose(ifp);
      fputs(".bp\n", ofp);
   }
   else if (access("class_header", R_OK) == 0) {
      ifp = gfopen("class_header", "r");
      while ((c = getc(ifp)) != EOF)
	 putc(c, ofp);
      gfclose(ifp);
      fputs(".bp\n", ofp);
   }
   ifp = gfopen(database, "r");
   while ((p = fgets(line, maxline, ifp)) != NULL && !isname(line))
      fputs(line, ofp);    /* run through any header lines in database */
   if (p != NULL) {
      fputs(BB, ofp);
      fputs(line, ofp);                             /* first name line */
      while (fgets(line, maxline, ifp) != NULL) {
	 if (isname(line)) {
	    fputs(EB, ofp);
	    fputs(BB, ofp);
	 }
	 fputs(line, ofp);
      }
      fputs(EB, ofp);
   }
   gfclose(ifp);
   compute_statistics(database);
   /***=
     *   If database is the filename "class",
     *   then compute_statistics() causes statistics
     *   to be printed in the file named class_statistics.
   =***/
   strcpy(cstatfn, database);
   strcat(cstatfn, "_statistics");        /* example: class_statistics */
   if (access(cstatfn, R_OK) == 0) {
      fputs(".bp\n", ofp);
      ifp = gfopen(cstatfn, "r");
      while ((c = getc(ifp)) != EOF)
	 putc(c, ofp);
      gfclose(ifp);
   }
   gfclose(ofp);
   if (test_mode) {
      printf("TEST MODE: Are you ready to view the file %s?  ", tfn);
      cx = reply();
      if (cx == 'y' || cx == '\n') {
	 strcpy(cmnd, "vi ");
	 strcat(cmnd, tfn);
	 gsystem(cmnd);
      }
      gremove(tfn);
   }
   else {
      strcpy(cmnd, "(nroff -me -Tlpr ");
      strcat(cmnd, tfn);
      strcat(cmnd, " | lpr -Pnarrow; /bin/rm ");
      strcat(cmnd, tfn);
      strcat(cmnd, ") &");
      gsystem(cmnd);
      printf("%s%s%s\n%s\n\n",
	 "Information generated from the file ", database, " is being",
	 "printed on the xerox laser printer at the computer center.");
   }
}

// ---
// Monday   23:48:20 PST   27 January 1986
// Sunday   17:22:20 PST   25 October 1987
//
// Three choices for printing on paper are offered:
//
//    1  print the database
//    2  print abstracts of the database
//    3  print a class roster
//   
// In addition, test versions of these are offered.
//

void print_on_paper(cchr* database)
{
   int   option;
   int   test_mode = 0;

   printf("%s%s%s%s%s%s%s%s%s",
      "Options for printing on paper:\n",
      "   1  print the database\n",
      "   2  print abstracts of the database\n",
      "   3  print a class roster\n",
      "   4  test mode - print the database\n",
      "   5  test mode - print abstracts of the database\n",
      "   6  test mode - print a class roster\n",
      "   7  quit\n\n",
      "Enter your option number: ");
   option = get_int_reply(1, 7);
   putchar('\n');
   if (option >= 4 && option <= 6)
      test_mode = 1;
   switch (option) {
   case 1:
   case 4:
      print_database_on_paper(database, test_mode);
      break;
   case 2:
   case 5:
      print_abstracts_on_paper(database, test_mode);
      break;
   case 3:
   case 6:
      print_roster_on_paper(database, test_mode);
      break;
   case 7:
      break;
   default:
      printf("\nPROGRAMMER ERROR in print_on_paper() - bye.\n\n");
      exit(1);
   }
}

// ---
// Tuesday   22:47:46 PDT   13 May 1986
//
// Print a roster of the names in the class database.
// The names should be printed in alphabetical order
// reading down the page, three columns per page.
// The roster is to be used to enter scores.
//
// The multi-column format is convenient for writing down
// scores that can then be easily entered in the machine.
// This is more convenient than trying to sort examinations
// and then trying to enter the scores directly from the exams.
//
// Thursday   12:31:02 PST   20 November 1986
//
// Rework the code to use ditroff instead of nroff
// so that .sp 0.5 will work.  The roster needs some
// space between names.
//

// ---
// The header
//
//    print_on_paper.h
// 
// gets used in only two functions:
//
//    print_roster_on_paper()
//    wrt_ditroff_lines()
//
// I have moved its inclusion
// to the top of this file.
//

void print_roster_on_paper(cchr* database, int test_mode)
{
   char****   a;
   char       command[maxline];
   char       line[maxline];
   char       tfn[maxstring];
   int        c;
   int        cnt;
   int        i;
   int        j;
   int        k;
   int        npages;
   dbl*       end_col;
   FILE*      ifp;
   FILE*      ofp;
   name*      head = NULL;
   name*      p;

   ifp = gfopen(database, "r");
   while (fgets(line, maxline, ifp) != NULL)
      if (isname(line)) {
	 if (head == NULL)
	    head = p = (name*) gmalloc(sizeof(name));
	 else
	    p = p -> next = (name*) gmalloc(sizeof(name));
	 for (i = 0; i < N - 1 && line[i] != '\n'; ++i)
	    p -> name[i] = line[i];
	 p -> name[i] = '\0';
      }
   if (head != NULL)
      p -> next = NULL;
   gfclose(ifp);
   for (cnt = 0, p = head; p != NULL; p = p -> next)
      ++cnt;
   npages = cnt / (L * C) + (cnt % (L * C) > 0);
   /***=
     *   Make an array so that names can be
     *   printed C columns per page, L lines per page.
   =***/
   a = (char ****) gcalloc((unsigned) npages, sizeof(char ***));
   for (i = 0; i < npages; ++i) {
      a[i] = (char ***) gcalloc((unsigned) L, sizeof(char **));
      for (j = 0; j < L; ++j)
	 a[i][j] = (char **) gcalloc((unsigned) C, sizeof(char *));
   }
   /***=
     *   In the nested for loops that follow,
     *   k comes before j so that names will be
     *   printed alphabetically by column.
   =***/
   p = head;
   for (i = 0; i < npages && p != NULL; ++i)
      for (k = 0; k < C && p != NULL; ++k)
	 for (j = 0; j < L && p != NULL; ++j) {
	    a[i][j][k] = p -> name;
	    p = p -> next;
	 }
   /***=
     *   Compute where each column ends on the line.
   =***/
   end_col = (double *) gcalloc(C, sizeof(double));
   for (i = 0; i < C; ++i)
      end_col[i] = (i + 1) * CL;                 /* CL = column length */
   /***=
     *   Now print the names.
   =***/
   tmpnam(tfn);
   ofp = gfopen(tfn, "w");
   wrt_ditroff_lines(database, ofp);
   for (i = 0; i < npages; ++i) {
      for (j = 0; j < L; ++j) {
	 for (k = 0; k < C; ++k)
	    if (a[i][j][k] != NULL) {
	       fprintf(ofp, "%s", a[i][j][k]);
	       fprintf(ofp, " \\l'|%.1fc'", end_col[k] - 1.0);
	       if (k < C - 1)
		  fprintf(ofp, "\\h'1c'");
	    }
	 fprintf(ofp, "\n.sp 0.5\n");    /* ditroff needed for .sp 0.5 */
      }
      if (i < npages - 1)
	 fprintf(ofp, ".bp\n");
   }
   gfclose(ofp);
   if (test_mode) {
      printf("\nTEST MODE:  Are you ready to view the file %s?  ", tfn);
      if ((c = reply()) == 'y' || c == '\n') {
	 printf("\nStandby, vi is coming up ...\n\n");
	 sprintf(command, "vi %s", tfn);
	 gsystem(command);
      }
      gremove(tfn);
      printf("\nThe file %s has been removed.\n\n", tfn);
   }
   else {
      sprintf(command, "%s%s%s%s%s%s",
	 "(ditroff.87 -me -Tx97 ", tfn, " | ditplus | lpr -Ptplus; ",
	 "rm ", tfn, ") &");
      gsystem(command);
      printf("%s\n%s\n\n",
	 "The class roster is being printed on the",
	 "xerox laser printer at the computer center.");
   }
}
