/*
// The function reorder() can call reorder_by().
// The function reorder_by() can call sort_by_score().
// At this point one or more score lines are know to exist.
//
// a[] := array of structures
// p[] := array of pointers to structures with p[i] = &a[i]
// nil := number of info lines associated with each name line
// nn  := number of name lines in database
//     := size of the arrays a[] and p[]
//
// The info lines with scores comprise a ragged array.
// The index m is used to specify the info line.
// The index n is used to specify the score on the info line
// that is to be used for sorting the database.
//
// qsort() is used to sort p[] according to a particular score.
//
// Note: both cll_info_lines() and cll_score_lines() rewind ifp.
*/

#include "grade.h"

void sort_by_score(NAIL* a, NAIL** p, int nil, int nn, FILE* ifp)
{
   /*
   //  We used the parameters nil and nn to be consistent.
   */
   char         line[maxline];
   char*        s;
   char*        t;
   int          go;
   int          i;
   int          j;
   int          score_cnt;
   int          m;                  /* the mth info line is to be used */
   int          n; /* the nth score on the mth info line is to be used */
   dbl          score;
   INFO_LINE*   hp;
   INFO_LINE*   q;
   
   hp = cll_info_lines(ifp);
   assert(nil >= 1);
   if (nil == 1) {
      m = 1;
      assert(isscore(hp -> line));
      strcpy(line, hp -> line);
      s = strchr(line, ':') + 1;
      for (t = s; *t != '\0'; ++t) {
	 go =    (*t == '/' && *(t + 1) == '/')
	      || (*t == '/' && *(t + 1) == '*')
	      || *t == '#';
	 if (go) {
	    *t = '\0';                             /* kill the comment */
	    break;
	 }
      }
      score_cnt = word_cnt(s);
      assert(score_cnt >= 1);
      if (score_cnt == 1)
	 n = 1;
   }
   if ((nil == 1 && score_cnt > 1) || nil > 1) {
      printf("Here is a snapshot of your database.\n\n");
      snapshot(ifp);
      if (nil > 1) {
	 printf("Here are the info lines extracted from the snapshot.\n\n");
	 for (i = 1, q = hp; q != NULL; ++i, q = q -> next)
	    printf("%3d%s", i, q -> line);
	 printf("\nWhich line contains the score to be used for sorting?  ");
	 m = get_int_reply(1, nil);
	 putchar('\n');
	 for (i = 1, q = hp; i < m; ++i, q = q -> next)
	    ;
	 if (!isscore(q -> line)) {
	    printf("ERROR:  A score line is needed - do it again.\n\n");
	    sort_by_score(a, p, nil, nn, ifp);
	    return;
	 }
	 strcpy(line, q -> line);
      }
      s = strchr(line, ':') + 1;
      for (t = s; *t != '\0'; ++t) {
	 go =    (*t == '/' && *(t + 1) == '/')
	      || (*t == '/' && *(t + 1) == '*')
	      || *t == '#';
	 if (go) {
	    *t = '\0';                             /* kill the comment */
	    break;
	 }
      }
      score_cnt = word_cnt(s);
      assert(score_cnt >= 1);
   }
   if (score_cnt == 1)
      n = 1;
   else {
      printf("%s\n\n%s\n%s%d%s",
	 "Here is the score line that is being considered:",
	 line,
	 "Indicate by an integer from 1 to ",
	 score_cnt,
	 " the score to be sorted on:  ");
      n = get_int_reply(1, score_cnt);
      putchar('\n');
   }
   /***=
     *   Now assign the correct score value
     *   to each member of the array of structures.
     *
     *   Caution: arrays are indexed from 0.
   =***/
   for (i = 0; i < nn; ++i) {
      s = strchr(a[i].info_line[m-1], ':') + 1;
      while (isspace(*s))
	 ++s;
      for (j = 1; j < n; ++j)
	 SET(s);
      if (sscanf(s, "%lf", &score) == 0)
	 score = 0.0;
      a[i].score = score;
   }
   qsort((char *) p, nn, sizeof(NAIL *), compare_scores);
}
