/*
// This is where files are opened.
//
//    ifp := infile pointer
//    ofp := outfile pointer
//
// CAUTION:
//    Since the tmp filename has to be known
//    in the calling environment, we cannot
//    create space for it here.
*/

/*
// The following are treated conceptually as pairs:
//
//    database       and       ifp
//    tfn            and       ofp
*/

#include "grade.h"

void startup(cchr* database, FILE** ifp_ptr, char* tfn, FILE** ofp_ptr)
{
   FILE*   ifp;
   FILE*   ofp;

   /*
   // The following assertions probably do nothing useful.
   // However, if this code were being written in C++,
   // such assertions definitely would be in order.
   */
   assert(database != NULL);
   assert(tfn != NULL);
   ifp = gfopen(database, "r");
   /*
   // Use fork() only after we know that the database is readable.
   */
   if (fork() == 0) {
      bkup(database);
      exit(0);
   }
   ofp = gfopen(tfn, "w");
   *ifp_ptr = ifp;
   *ofp_ptr = ofp;
}
